# LBFGSB

[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![Build Status](https://github.com/Gnimuc/LBFGSB.jl/workflows/CI/badge.svg)](https://github.com/Gnimuc/LBFGSB.jl/actions/workflows/ci.yml)
[![TagBot](https://github.com/Gnimuc/LBFGSB.jl/workflows/TagBot/badge.svg)](https://github.com/Gnimuc/LBFGSB.jl/actions/workflows/TagBot.yml)
[![codecov](https://codecov.io/gh/Gnimuc/LBFGSB.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/Gnimuc/LBFGSB.jl)

This is a Julia wrapper for [L-BFGS-B Nonlinear Optimization Code](http://users.iems.northwestern.edu/%7Enocedal/lbfgsb.html).

## Installation
```julia
pkg> add LBFGSB
```

## Usage
```julia
using LBFGSB

# define a function that maps a vector to a scalar
# let's define a multidimensional Rosenbrock function(https://en.wikipedia.org/wiki/Rosenbrock_function):
function f(x)
    y = 0.25 * (x[1] - 1)^2
    for i = 2:length(x)
        y += (x[i] - x[i-1]^2)^2
    end
    4y
end

# and its gradient function that maps a vector x to a vector z
function g!(z, x)
    n = length(x)
    t₁ = x[2] - x[1]^2
    z[1] = 2 * (x[1] - 1) - 1.6e1 * x[1] * t₁
    for i = 2:n-1
        t₂ = t₁
        t₁ = x[i+1] - x[i]^2
        z[i] = 8 * t₂ - 1.6e1 * x[i] * t₁
    end
    z[n] = 8 * t₁
end

# the first argument is the dimension of the largest problem to be solved
# the second argument is the maximum number of limited memory corrections
optimizer = L_BFGS_B(1024, 17)
n = 25  # the dimension of the problem
x = fill(Cdouble(3e0), n)  # the initial guess
# set up bounds
bounds = zeros(3, n)
for i = 1:n
    bounds[1,i] = 2  # represents the type of bounds imposed on the variables:
                     #  0->unbounded, 1->only lower bound, 2-> both lower and upper bounds, 3->only upper bound
    bounds[2,i] = isodd(i) ? 1e0 : -1e2  #  the lower bound on x, of length n.
    bounds[3,i] = 1e2  #  the upper bound on x, of length n.
end
# call the optimizer
# - m: the maximum number of variable metric corrections used to define the limited memory matrix
# - factr: the iteration will stop when (f^k - f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= factr*epsmch,
#     where epsmch is the machine precision, which is automatically generated by the code. Typical values for factr:
#     1e12 for low accuracy, 1e7 for moderate accuracy, 1e1 for extremely high accuracy
# - pgtol: the iteration will stop when max{|proj g_i | i = 1, ..., n} <= pgtol where pg_i is the ith component of the projected gradient
# - iprint: controls the frequency of output. iprint < 0 means no output:
#     iprint = 0 print only one line at the last iteration
#     0 < iprint < 99 print also f and |proj g| every iprint iterations
#     iprint = 99 print details of every iteration except n-vectors
#     iprint = 100 print also the changes of active set and final x
#     iprint > 100 print details of every iteration including x and g
# - maxfun: the maximum number of function evaluations
# - maxiter: the maximum number of iterations
julia> fout, xout = optimizer(f, g!, x, bounds, m=5, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
(1.0834900834300615e-9, [1.0, 1.0, 1.0, 1.00001, 1.00001, 1.00001, 1.00001, 1.00001, 1.00002, 1.00004  …  1.0026, 1.00521, 1.01045, 1.02101, 1.04246, 1.08672, 1.18097, 1.39469, 1.94516, 3.78366])

# if your func needs extra arguments, a closure can be used to do the trick:
# optimizer(λ->func(λ, extra_args...), x, bounds, m=5, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
```
This package also provides `lbfgsb`, a convenience function that computes the `bounds` input matrix and the `optimizer` internally. The inputs of `lbfgs` are the same as above, except for lower/upper bounds specified optionally as keyword parameters `lb`/`ub` (defaulting to `-Inf/Inf`, i.e. unbounded problem).  With the example above, an equivalent call to `lbfgsb` would be:
```julia
lb = [isodd(i) ? 1e0 : -1e2 for i in 1:n]
ub = 1e2
julia> fout, xout = lbfgsb(f, g!, x, lb=lb, ub=ub, m=5, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
```
The original examples/drivers in the L-BFGS-B library are translated in the `test` folder directly using low-level `setulb`.

using LBFGSB
using Test

@testset "driver1" begin
# translated from driver1.f
# "This simple driver demonstrates how to call the L-BFGS-B code to solve a sample
#  problem (the extended Rosenbrock function subject to bounds on the variables).
#  The dimension n of this problem is variable.

nmax = 1024   # the dimension of the largest problem to be solved
mmax = 17    # the maximum number of limited memory corrections

task = fill(Cuchar(' '), 60)    # fortran's blank padding
csave = fill(Cuchar(' '), 60)    # fortran's blank padding
lsave = zeros(Cint, 4)
isave = zeros(Cint, 44)
dsave = zeros(Cdouble, 29)

iprint = 1    # print output at every iteration

# "f is a DOUBLE PRECISION variable.  If the routine setulb returns with task(1:2)= 'FG',
#  then f must be set by the user to contain the value of the function at the point x."
f = 0.0

# "g is a DOUBLE PRECISION array of length n.  If the routine setulb returns with taskb(1:2)= 'FG',
#  then g must be set by the user to contain the components of the gradient at the point x."
g = zeros(Cdouble, nmax)

wa = zeros(Cdouble, 2mmax*nmax + 5nmax + 11mmax*mmax + 8mmax)
iwa = zeros(Cint, 3*nmax)

# specify the tolerances in the stopping criteri
factr = Ref{Cdouble}(1e7)
pgtol = Ref{Cdouble}(1e-5)

n = 25    # the dimension n of the sample problem
m = 5     # the number of m of limited memory correction stored

# provide nbd which defines the bounds on the variables:
nbd = zeros(Cint, nmax)
l = zeros(Cdouble, nmax)    # the lower bounds
u = zeros(Cdouble, nmax)    # the upper bounds
# "First set bounds on the odd-numbered variables."
for i = 1:2:n
    nbd[i] = 2
    l[i] = 1e0
    u[i] = 1e2
end
# "Next set bounds on the even-numbered variables."
for i = 2:2:n
    nbd[i] = 2
    l[i] = -1e2
    u[i] = 1e2
end

# "We now define the starting point."
x = zeros(Cdouble, nmax)
for i = 1:n
    x[i] = 3e0
end

println("Solving sample problem.")
println(" (f = 0.0 at the optimal solution.)")

# "We start the iteration by initializing task."
task[1:5] = b"START"

## ------- the beginning of the loop ----------
let
    @label CALLLBFGSB

    # This is the call to the L-BFGS-B code.
    setulb(n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, iprint, csave, lsave, isave, dsave)

    # "the minimization routine has returned to request the function f and gradient g values at the current x."
    if task[1:2] == b"FG"
        # "Compute function value f for the sample problem."
        f = 0.25 * (x[1] - 1)^2
        for i = 2:n
            f = f + (x[i] - x[i-1]^2)^2
        end

        f = 4 * f

        # "Compute gradient g for the sample problem."
        t₁ = x[2] - x[1]^2
        g[1] = 2 * (x[1] - 1) - 1.6e1 * x[1] * t₁
        for i = 2:n-1
            t₂ = t₁
            t₁ = x[i+1] - x[i]^2
            g[i] = 8 * t₂ - 1.6e1 * x[i] * t₁
        end
        g[n] = 8 * t₁

        # "go back to the minimization routine."
        @goto CALLLBFGSB
    end

    # "the minimization routine has returned with a new iterate, and we have opted to continue the iteration."
    task[1:5] == b"NEW_X" && @goto CALLLBFGSB

    # ---------- the end of the loop -------------
    # "If task is neither FG nor NEW_X we terminate execution."
end

@test f ≈ 1.083490083518441e-9

end # EOB

struct L_BFGS_B
    nmax::Int
    mmax::Int
    task::Vector{UInt8}
    csave::Vector{UInt8}
    lsave::Vector{Cint}
    isave::Vector{Cint}
    dsave::Vector{Cdouble}
    wa::Vector{Cdouble}
    iwa::Vector{Cint}
    g::Vector{Cdouble}
    nbd::Vector{Cint}
    l::Vector{Cdouble}
    u::Vector{Cdouble}
    function L_BFGS_B(nmax, mmax)
        task = fill(Cuchar(' '), 60)
        csave = fill(Cuchar(' '), 60)
        lsave = zeros(Cint, 4)
        isave = zeros(Cint, 44)
        dsave = zeros(Cdouble, 29)
        wa = zeros(Cdouble, 2mmax*nmax + 5nmax + 11mmax*mmax + 8mmax)
        iwa = zeros(Cint, 3*nmax)
        g = zeros(Cdouble, nmax)
        nbd = zeros(Cint, nmax)
        l = zeros(Cdouble, nmax)
        u = zeros(Cdouble, nmax)
        new(nmax, mmax, task, csave, lsave, isave, dsave, wa, iwa, g, nbd, l, u)
    end
end

function (obj::L_BFGS_B)(func, grad!, x0::AbstractVector, bounds::AbstractMatrix;
    m=10, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
    x = copy(x0)
    n = length(x)
    f = 0.0
    # clean up
    fill!(obj.task, Cuchar(' '))
    fill!(obj.csave, Cuchar(' '))
    fill!(obj.lsave, zero(Cint))
    fill!(obj.isave, zero(Cint))
    fill!(obj.dsave, zero(Cdouble))
    fill!(obj.wa, zero(Cdouble))
    fill!(obj.iwa, zero(Cint))
    fill!(obj.g, zero(Cdouble))
    fill!(obj.nbd, zero(Cint))
    fill!(obj.l, zero(Cdouble))
    fill!(obj.u, zero(Cdouble))
    # set bounds
    for i = 1:n
        obj.nbd[i] = bounds[1,i]
        obj.l[i] = bounds[2,i]
        obj.u[i] = bounds[3,i]
    end
    # start
    obj.task[1:5] = b"START"
    while true
        iprint == 1 && flush(stdout)  # PR 12
        setulb(n, m, x, obj.l, obj.u, obj.nbd, f, obj.g, factr, pgtol, obj.wa,
               obj.iwa, obj.task, iprint, obj.csave, obj.lsave, obj.isave, obj.dsave)
        if obj.task[1:2] == b"FG"
            f = func(x)
            grad!(obj.g, x)
        elseif obj.task[1:5] == b"NEW_X"
            if obj.isave[30] ≥ maxiter
                obj.task[1:43] = b"STOP: TOTAL NO. of ITERATIONS REACHED LIMIT"
            elseif obj.isave[34] ≥ maxfun
                obj.task[1:52] = b"STOP: TOTAL NO. of f AND g EVALUATIONS EXCEEDS LIMIT"
            end
        else
            return f, x
        end
    end
end

function (obj::L_BFGS_B)(func, x0::AbstractVector, bounds::AbstractMatrix;
    m=10, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
    x = copy(x0)
    n = length(x)
    f = 0.0
    # clean up
    fill!(obj.task, Cuchar(' '))
    fill!(obj.csave, Cuchar(' '))
    fill!(obj.lsave, zero(Cint))
    fill!(obj.isave, zero(Cint))
    fill!(obj.dsave, zero(Cdouble))
    fill!(obj.wa, zero(Cdouble))
    fill!(obj.iwa, zero(Cint))
    fill!(obj.g, zero(Cdouble))
    fill!(obj.nbd, zero(Cint))
    fill!(obj.l, zero(Cdouble))
    fill!(obj.u, zero(Cdouble))
    # set bounds
    for i = 1:n
        obj.nbd[i] = bounds[1,i]
        obj.l[i] = bounds[2,i]
        obj.u[i] = bounds[3,i]
    end
    # start
    obj.task[1:5] = b"START"
    while true
        iprint == 1 && flush(stdout)  # PR 12
        setulb(n, m, x, obj.l, obj.u, obj.nbd, f, obj.g, factr, pgtol, obj.wa,
               obj.iwa, obj.task, iprint, obj.csave, obj.lsave, obj.isave, obj.dsave)
        if obj.task[1:2] == b"FG"
            f, grad = func(x)
            obj.g[1:n] = grad
        elseif obj.task[1:5] == b"NEW_X"
            if obj.isave[30] ≥ maxiter
                obj.task[1:43] = b"STOP: TOTAL NO. of ITERATIONS REACHED LIMIT"
            elseif obj.isave[34] ≥ maxfun
                obj.task[1:52] = b"STOP: TOTAL NO. of f AND g EVALUATIONS EXCEEDS LIMIT"
            end
        else
            return f, x
        end
    end
end

function typ_bnd(lb,ub)
        lb > ub && error("Inconsistent bounds")
    
        lbinf = lb==-Inf
        ubinf = ub==+Inf

        lbinf && ubinf && return 0
        !lbinf && ubinf && return 1
        !lbinf && !ubinf && return 2
        lbinf && !ubinf && return 3
end

function _opt_bounds(n,m,lb,ub)
    optimizer=L_BFGS_B(n,m)
    bounds=zeros(3,n)
    bounds[2,:].=lb
    bounds[3,:].=ub
    bounds[1,:].= typ_bnd.(lb,ub)
    return optimizer,bounds
end

function lbfgsb(f,g!,x0;m=10,lb=[-Inf for i in x0],ub=[Inf for i in x0],kwargs...)
    n=length(x0)
    optimizer,bounds=_opt_bounds(n,m,lb,ub)
   
    optimizer(f,g!,x0,bounds;m=m,kwargs...)
end

function lbfgsb(f,x0;m=10,lb=[-Inf for i in x0],ub=[Inf for i in x0],kwargs...)
    n=length(x0)
    optimizer,bounds=_opt_bounds(n,m,lb,ub)
    
    optimizer(f,x0,bounds;m=m,kwargs...)
end

using LBFGSB
using Test

# define a function
function f(x)
    n = length(x)
    y = 0.25 * (x[1] - 1)^2
    for i = 2:n
        y += (x[i] - x[i-1]^2)^2
    end
    4y
end

# and its gradient function that maps a vector x to a vector z
function g!(z, x)
    n = length(x)
    t₁ = x[2] - x[1]^2
    z[1] = 2 * (x[1] - 1) - 1.6e1 * x[1] * t₁
    for i = 2:n-1
        t₂ = t₁
        t₁ = x[i+1] - x[i]^2
        z[i] = 8 * t₂ - 1.6e1 * x[i] * t₁
    end
    z[n] = 8 * t₁
end

@testset "wrapper" begin
    # the first argument is the dimension of the largest problem to be solved
    # the second argument is the maximum number of limited memory corrections
    optimizer = L_BFGS_B(1024, 17)
    n = 25  # the dimension of the problem
    x = fill(Cdouble(3e0), n)  # the initial guess
    # set up bounds
    bounds = zeros(3, n)
    for i = 1:n
        bounds[1,i] = 2  # represents the type of bounds imposed on the variables:
                         #  0->unbounded, 1->only lower bound, 2-> both lower and upper bounds, 3->only upper bound
        bounds[2,i] = isodd(i) ? 1e0 : -1e2  #  the lower bound on x, of length n.
        bounds[3,i] = 1e2  #  the upper bound on x, of length n.
    end
    # call the optimizer
    # - m: the maximum number of variable metric corrections used to define the limited memory matrix
    # - factr: the iteration will stop when (f^k - f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= factr*epsmch,
    #     where epsmch is the machine precision, which is automatically generated by the code. Typical values for factr:
    #     1e12 for low accuracy, 1e7 for moderate accuracy, 1e1 for extremely high accuracy
    # - pgtol: the iteration will stop when max{|proj g_i | i = 1, ..., n} <= pgtol where pg_i is the ith component of the projected gradient
    # - iprint: controls the frequency of output. iprint < 0 means no output:
    #     iprint = 0 print only one line at the last iteration
    #     0 < iprint < 99 print also f and |proj g| every iprint iterations
    #     iprint = 99 print details of every iteration except n-vectors
    #     iprint = 100 print also the changes of active set and final x
    #     iprint > 100 print details of every iteration including x and g
    # - maxfun: the maximum number of function evaluations
    # - maxiter: the maximum number of iterations
    fout, xout = optimizer(f, g!, x, bounds, m=5, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
    @test fout ≈ 1.083490083518441e-9
    
    #testing the original wrapper:
    function g(x)
        n = length(x)
        z = zeros(n)
        t₁ = x[2] - x[1]^2
        z[1] = 2 * (x[1] - 1) - 1.6e1 * x[1] * t₁
        for i = 2:n-1
            t₂ = t₁
            t₁ = x[i+1] - x[i]^2
            z[i] = 8 * t₂ - 1.6e1 * x[i] * t₁
        end
        z[n] = 8 * t₁
        z
    end
    func(x) = (f(x), g(x))
    fout2, xout2 = optimizer(func, x, bounds, m=5, factr=1e7, pgtol=1e-5, iprint=-1, maxfun=15000, maxiter=15000)
    @test fout2 ≈ 1.083490083518441e-9
end

@testset "lbfgsb" begin
    #  0->unbounded, 1->only lower bound, 2-> both lower and upper bounds, 3->only upper bound
    lb=[-Inf,-Inf,-2.,6f0]
    ub=[Inf,3.,2,Inf]
    btyps=[0,3,2,1]
    
    @test LBFGSB.typ_bnd.(lb,ub) == btyps
    
    @test_throws ErrorException LBFGSB.typ_bnd(6,-1.)
    
    n,m=4,6
    o,b=LBFGSB._opt_bounds(n,m,lb,ub)
    
    @test size(b)==(3,n)
    @test b[2,:] == lb
    @test b[3,:] == ub
    @test b[1,:] == btyps
    
    od=L_BFGS_B(n,m)
    @test all(getproperty(od,i)==getproperty(o,i) for i in fieldnames(L_BFGS_B))
    
    fout,xout=lbfgsb(x->0.5sum(abs,x),(g,x)->g.=x,100*rand(3),lb=[0.5,-Inf,-0.1],ub=[Inf,0.2,Inf])
    @test fout ≈ 0.25
    @test xout ≈ [0.5,0,0]
 end

using LBFGSB
using Test

@testset "driver3" begin
# translated from driver3.f
# "This time-controlled driver shows that it is possible to terminate a run by
#  elapsed CPU time, and yet be able to print all desired information. This driver
#  also illustrates the use of two stopping criteria that may be used in conjunction
#  with a limit on execution time. The sample problem used here is the same as in
#  driver1 and driver2 (the extended Rosenbrock function with bounds on the variables).

nmax = 1024   # the dimension of the largest problem to be solved
mmax = 17    # the maximum number of limited memory corrections

task = fill(Cuchar(' '), 60)    # fortran's blank padding
csave = fill(Cuchar(' '), 60)    # fortran's blank padding
lsave = zeros(Cint, 4)
isave = zeros(Cint, 44)
dsave = zeros(Cdouble, 29)

# "We specify a limite on the CPU time (in seconds)."
tlimit = 0.2

# "We suppress the default output.
#  (The user could also elect to use the default output by choosing iprint >= 0.)"
iprint = -1

# "f is a DOUBLE PRECISION variable.  If the routine setulb returns with task(1:2)= 'FG',
#  then f must be set by the user to contain the value of the function at the point x."
f = 0.0

# "g is a DOUBLE PRECISION array of length n.  If the routine setulb returns with taskb(1:2)= 'FG',
#  then g must be set by the user to contain the components of the gradient at the point x."
g = zeros(Cdouble, nmax)

wa = zeros(Cdouble, 2mmax*nmax + 5nmax + 11mmax*mmax + 8mmax)
iwa = zeros(Cint, 3*nmax)

# "We suppress both code-supplied stopping tests because we will provide our own termination conditions"
factr = 0.0
pgtol = 0.0

n = 1000    # the dimension n of the sample problem
m = 10      # the number of m of limited memory correction stored

# provide nbd which defines the bounds on the variables:
nbd = zeros(Cint, nmax)
l = zeros(Cdouble, nmax)    # the lower bounds
u = zeros(Cdouble, nmax)    # the upper bounds
# "First set bounds on the odd-numbered variables."
for i = 1:2:n
    nbd[i] = 2
    l[i] = 1e0
    u[i] = 1e2
end
# "Next set bounds on the even-numbered variables."
for i = 2:2:n
    nbd[i] = 2
    l[i] = -1e2
    u[i] = 1e2
end

# "We now define the starting point."
x = zeros(Cdouble, nmax)
for i = 1:n
    x[i] = 3e0
end

println("Solving sample problem.")
println(" (f = 0.0 at the optimal solution.)")

# "We start the iteration by initializing task."
task[1:5] = b"START"

## ------- the beginning of the loop ----------
time1Ref = Ref{Cdouble}(0)
time2Ref = Ref{Cdouble}(0)

timer(time1Ref)

let
    @label CALLLBFGSB

    # This is the call to the L-BFGS-B code.
    setulb(n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, iprint, csave, lsave, isave, dsave)

    # "the minimization routine has returned to request the function f and gradient g values at the current x."
    if task[1:2] == b"FG"
        # "Before evaluating f and g we check the CPU time spent."
        timer(time2Ref)

        if time2Ref[] - time1Ref[] > tlimit
            task[1:4] = b"STOP"
            # "In this driver we have chosen to disable the printing options of the
            #  code (we set iprint=-1); instead we are using customized output: we
            #  print the latest value of x, the corresponding function value f and
            #  the norm of the projected gradient |proj g|."

            println("STOP: CPU EXCEEDING THE TIME LIMIT.")

            # "We print the latest iterate contained in wa(j+1:j+n), where j = 3*n+2*m*n+11*m**2"
            j = 3n + 2m*n + 11m^2
            println("Latest iterate X =")
            for i = j+1:j+n
                println("wa[$i] = ", wa[i])
            end
        else
            # "Compute function value f for the sample problem."
            f = 0.25 * (x[1] - 1)^2
            for i = 2:n
                f = f + (x[i] - x[i-1]^2)^2
            end

            f = 4 * f

            # "Compute gradient g for the sample problem."
            t₁ = x[2] - x[1]^2
            g[1] = 2 * (x[1] - 1) - 1.6e1 * x[1] * t₁
            for i = 2:n-1
                t₂ = t₁
                t₁ = x[i+1] - x[i]^2
                g[i] = 8 * t₂ - 1.6e1 * x[i] * t₁
            end
            g[n] = 8 * t₁
        end
            # "go back to the minimization routine."
            @goto CALLLBFGSB
    end

    # "the minimization routine has returned with a new iterate, The time limit
    #  has not been reached, and we test whether the following two stopping tests are satisfied:
    if task[1:5] == b"NEW_X"
        # "1) Terminate if the total number of f and g evaluations exceeds 900."
        isave[34] ≥ 900 && (task[1:4] = b"STOP"; terminate_info="TOTAL NO. of f AND g EVALUATIONS EXCEEDS LIMIT")

        # "2) Terminate if  |proj g|/(1+|f|) < 1.0d-10"
        dsave[13] ≤ 1e-10 * (1e0 + abs(f)) && (task[1:4] = b"STOP"; terminate_info="THE PROJECTED GRADIENT IS SUFFICIENTLY SMALL")


        # "We wish to print the following information at each iteration:"
        # "1) the current iteration number, isave(30),"
        # "2) the total number of f and g evaluations, isave(34),"
        # "3) the value of the objective function f,"
        # "4) the norm of the projected gradient,  dsave(13)"

        println("Iterate ", isave[30], "  nfg = ", isave[34], "  f = ", f, "  |proj g| = ", dsave[13])

        # "If the run is to be terminated, we print also the information contained
        #  in task as well as the final value of x."
        if task[1:4] == b"STOP"
            println(terminate_info)
            for i = 1:n
                println("x($i) = ", x[i])
            end
        end

        # "go back to the minimization routine."
        @goto CALLLBFGSB
    end

    # ---------- the end of the loop -------------
    # "If task is neither FG nor NEW_X we terminate execution."

end

end # EOB

"""
    setulb(n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, iprint, csave, lsave, isave, dsave)
This function wraps L-BFGS-B's fortran subroutine `setulb` which partitions the working arrays `wa` and `iwa`,
and then uses the limited memory BFGS method to solve the bound constrained optimization problem by calling `mainlb`.

Note, `nmax` is the dimension of the largest problem to be solved, `mmax` is the maximum number of limited memory corrections.

# Arguments
- `n::Ref{Cint}`: the dimension of the problem.
- `m::Ref{Cint}`: the maximum number of variable metric corrections used to define the limited memory matrix.
- `x::Vector{Cdouble}`: an approximation to the solution, of length n.
- `l::Vector{Cdouble}`: the lower bound on x, of length n.
- `u::Vector{Cdouble}`: the upper bound on x, of length n.
- `nbd::Vector{Cint}`: represents the type of bounds imposed on the variables, and must be specified as follows:
    1. nbd[i]=0 if x[i] is unbounded;
    2. nbd[i]=1 if x(i) has only a lower bound;
    3. nbd[i]=2 if x[i] has both lower and upper bounds;
    4. nbd[i]=3 if x[i] has only an upper bound.
- `f::Ref{Cdouble}`: the value of the function at x(on first entry f is unspecified).
- `g::Vector{Cdouble}`: the value of the gradient at x(on first entry g is unspecified).
- `factr::Ref{Cdouble}`: the iteration will stop when (f^k - f^{k+1})/max{|f^k|,|f^{k+1}|,1} <= factr*epsmch,
    where epsmch is the machine precision, which is automatically generated by the code. Typical values for factr:
    * 1.e12 for low accuracy;
    * 1.e7 for moderate accuracy;
    * 1.e1 for extremely high accuracy.
- `pgtol::Ref{Cdouble}`: the iteration will stop when max{|proj g_i | i = 1, ..., n} <= pgtol where pg_i is the ith component of the projected gradient.
- `wa::Vector{Cdouble}`: the working array of length (2mmax + 5)nmax + 12mmax^2 + 12mmax.
- `iwa::Vector{Cint}`: the integer working array of length 3nmax.
- `task::Vector{Cuchar}`: a working string of characters of length 60 indicating the current job when entering and quitting this function.
- `iprint::Ref{Cint}`: it controls the frequency and type of output generated:
    1. iprint<0 no output is generated;
    2. iprint=0 print only one line at the last iteration;
    3. 0<iprint<99 print also f and |proj g| every iprint iterations;
    4. iprint=99 print details of every iteration except n-vectors;
    5. iprint=100 print also the changes of active set and final x;
    6. iprint>100 print details of every iteration including x and g.
    7. when iprint > 0, the file iterate.dat will be created to summarize the iteration.
- `csave::Vector{Cuchar}`: a working string of characters of length 60.
- `lsave::Vector{Bool}`: a logical working array of dimension 4. if `task` = NEW_X, the following information is available:
    1. if lsave[1] == true then the initial X has been replaced by its projection in the feasible set;
    2. if lsave[2] == true then the problem is constrained;
    3. if lsave[3] == true then each variable has upper and lower bounds.
- `isave::Vector{Cint}`: an integer working array of dimension 44. if `task` = NEW_X, the following information is available:
    1. isave[22] = the total number of intervals explored in the search of Cauchy points;
    2. isave[26] = the total number of skipped BFGS updates before the current iteration;
    3. isave[30] = the number of current iteration;
    4. isave[31] = the total number of BFGS updates prior the current iteration;
    5. isave[33] = the number of intervals explored in the search of Cauchy point in the current iteration;
    6. isave[34] = the total number of function and gradient evaluations;
    7. isave[36] = the number of function value or gradient evaluations in the current iteration;
    8. if isave[37] = 0  then the subspace argmin is within the box;
    9. if isave[37] = 1  then the subspace argmin is beyond the box;
    10. isave[38] = the number of free variables in the current iteration;
    11. isave[39] = the number of active constraints in the current iteration;
    12. n + 1 - isave[40] = the number of variables leaving the set of active constraints in the current iteration;
    13. isave[41] = the number of variables entering the set of active constraints in the current iteration.
- `dsave::Vector{Cdouble}`: a double precision working array of dimension 29. if `task` = NEW_X, the following information is available:
    1. dsave[1] = current 'theta' in the BFGS matrix;
    2. dsave[2] = f(x) in the previous iteration;
    3. dsave[3] = factr*epsmch;
    4. dsave[4] = 2-norm of the line search direction vector;
    5. dsave[5] = the machine precision epsmch generated by the code;
    6. dsave[7] = the accumulated time spent on searching for Cauchy points;
    7. dsave[8] = the accumulated time spent on subspace minimization;
    8. dsave[9] = the accumulated time spent on line search;
    9. dsave[11] = the slope of the line search function at the current point of line search;
    10. dsave[12] = the maximum relative step length imposed in line search;
    11. dsave[13] = the infinity norm of the projected gradient;
    12. dsave[14] = the relative step length in the line search;
    13. dsave[15] = the slope of the line search function at the starting point of the line search;
    14. dsave[16] = the square of the 2-norm of the line search direction vector.
"""
function setulb(n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, iprint, csave, lsave, isave, dsave)
    ccall((:setulb_, liblbfgsb), Cvoid, (Ref{Cint}, Ref{Cint}, Ref{Cdouble}, Ref{Cdouble}, Ref{Cdouble},
          Ref{Cint}, Ref{Cdouble}, Ref{Cdouble}, Ref{Cdouble}, Ref{Cdouble}, Ref{Cdouble},
          Ref{Cint}, Ref{Cuchar}, Ref{Cint}, Ref{Cuchar}, Ref{Cint}, Ref{Cint}, Ref{Cdouble}, Csize_t, Csize_t),
          n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, iprint, csave, lsave, isave, dsave, 60, 60)
end

"""
    timer(x)
The double precision cpu timing subroutine in the L-BFGS-B code.
"""
timer(x) = ccall((:timer_, liblbfgsb), Cvoid, (Ref{Cdouble},), x)
